#pragma once

#include "CoreMinimal.h"
#include "K38DogBaseState.h"
#include "Templates/SubclassOf.h"
#include "DBDTunableRowHandle.h"
#include "EGameState.h"
#include "K38HoldingSurvivorDogState.generated.h"

class UStatusEffect;
class UInteractionDefinition;
class ADBDPlayerState;

UCLASS(Blueprintable)
class THEK38_API UK38HoldingSurvivorDogState : public UK38DogBaseState
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSubclassOf<UStatusEffect> _hinderedStatusEffectClass;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FDBDTunableRowHandle _hinderedEffectPercent;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FDBDTunableRowHandle _hinderedEffectDuration;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TArray<TSubclassOf<UInteractionDefinition>> _interactionTypesCancelledByDogStruggle;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TArray<TSubclassOf<UInteractionDefinition>> _interactionsCancellingDogStruggle;

private:
	UFUNCTION(BlueprintCallable)
	void Authority_OnSurvivorHeldGameStateChanged(ADBDPlayerState* playerState, const EGameState gameState);

public:
	UK38HoldingSurvivorDogState();
};

FORCEINLINE uint32 GetTypeHash(const UK38HoldingSurvivorDogState) { return 0; }
